<?php

namespace Dog\Utils;

use FML\Controls\Quad;
use FML\Controls\Frame;
use FML\Controls\Label;
use FML\Script\ScriptLabel;

class UI
{
    const ColorLightBlue    = 'b3e5fc';
    const ColorMediumBlue   = '263FA8';
    const ColorDarkBlue     = '000514';
    const ColorRed          = "FF0D0D";
    const ColorDarkRed      = "AA0D0D";
    const ColorGreenFive    = "000A05";
    const ColorGreenFour    = "003228";
    const ColorGreenThree   = "005F46";
    const ColorGreenTwo     = "009B5F";
    const ColorGreenOne     = "6EFAA0";

    const GameFontBlack     = "GameFontBlack";
    const GameFontExtraBold = "GameFontExtraBold";
    const GameFontSemiBold  = "GameFontSemiBold";
    const GameFontRegular   = "GameFontRegular";

    public static function Button(string $text, string $action, string $color, float $posX, float $posY, float $posZ = null): Frame
    {
        $frame = new Frame();
        $bg = new Quad("quad-button-bg");
        $frame->addChild($bg);
        $bg->setBackgroundColor($color)
            ->setPosition($posX, $posY, $posZ)
            ->setSize(30, 8)
            ->setOpacity(0.5)
            ->setAlign("center", "bottom")
            ->setAction($action)
            ->setScriptEvents(true)
            ->addScriptText('Quad.Opacity = 0.8;', ScriptLabel::MOUSEOVER)
            ->addScriptText('Quad.Opacity = 0.5;', ScriptLabel::MOUSEOUT);

        $label = new Label("label-button-text");
        $frame->addChild($label);
        $label->setTextFont(self::GameFontExtraBold)
            ->setPosition($posX, $posY + 4, $posZ)
            ->setText($text)
            ->setTextPrefix("\$i\$t")
            ->setTextSize(1)
            ->setAlign("center", "center");

        return $frame;
    }
    
    public static function SquareButton(string $text, string $action, string $color, float $size, float $posX, float $posY, float $posZ = null, float $opacity = 0.5): Frame
    {
        $frame = new Frame();
        $bg = new Quad("quad-button-bg");
        $frame->addChild($bg);
        $bg->setBackgroundColor($color)
            ->setPosition($posX, $posY, $posZ)
            ->setSize($size, $size)
            ->setOpacity($opacity)
            ->setAlign("center", "bottom")
            ->setAction($action)
            ->setScriptEvents(true)
            ->addScriptText('Quad.Opacity = 0.8;', ScriptLabel::MOUSEOVER)
            ->addScriptText('Quad.Opacity = 0.5;', ScriptLabel::MOUSEOUT);

        $label = new Label("label-button-text");
        $frame->addChild($label);
        $label->setTextFont(self::GameFontExtraBold)
            ->setPosition($posX, $posY + 4, $posZ)
            ->setText($text)
            ->setTextPrefix("\$i\$t")
            ->setTextSize(1)
            ->setAlign("center", "center");

        return $frame;
    }
}
